#include <stdio.h>
#include <stdlib.h>
#include <sched.h>

/* Simple command line utility to make processes real time
 * on linux.  This program needs to be run as root or setuid root.
 * No permission checks are done when the binary is setuid root, 
 * so be careful.  
 *
 * Written by:  Chris Studholme
 * Last Update: 12-Jan-1999
 * Copyright:   GPL (http://www.fsf.org/copyleft/gpl.html)
 */
 
main(int argc, char*argv[]) {
  if (argc<2) {
    fprintf(stderr,"Usage:\n\n  setrt pid\n");
    return 1;
  }
  
  int pid = atoi(argv[1]);
  
  if (pid<1) {
    fprintf(stderr,"setrt: invalid pid\n");
    return 1;
  }
  
  struct sched_param param;
  param.sched_priority=1;
  
  if (sched_setscheduler(pid,SCHED_FIFO,&param)!=0) {
    fprintf(stderr,"setrt: cannot set scheduler\n");
    return 1;
  }
  
  return 0;
}
